var express = require("express");
var bodyParser = require("body-parser");
var app = express();
var SqlString = require('sqlstring');
const util = require('util')
var mysql = require('mysql');
app.use(bodyParser.urlencoded({ extended: false }));
app.use(bodyParser.json());
app.get('/', function (req, res) {
    res.sendfile("index.html");
});
var con = mysql.createConnection({
    host: "win-app",
    port: "3306",
    user: "root",
    password: "2017",
    database: "cteportal_2018_05_22_2"
});

con.connect(function (err) {
    if (err) throw err;
    console.log("Connected!");
});
app.post('/filter/:table', function (req, res) {
    let totalCount;
    var filters = req.body.filters;
    var first = req.body.first;
    var globalFilter = req.body.globalFilter;
    var rows = req.body.rows;
    var sortField = req.body.sortField;
    var sortOrder = req.body.sortOrder;
    var table = [req.params.table];
    console.log(util.inspect(filters, false, null))
    console.log(first + " " + globalFilter + " " + rows + " " + sortField + " " + sortOrder + " " + table);
    //To calculate Total Count use MySQL count function
    var query = "Select count(*) as TotalCount from ??";
    query = mysql.format(query, table);
    con.query(query, function (err, rows) {
        if (err) {
            res.send(err);
        }
        else {
            totalCount = rows[0].TotalCount;
            console.log(totalCount);
            // res.send( totalCount);
        }
    });

    var query = "Select * from ??";
    var keys = [];
    for (var k in filters) keys.push(k);
    let cont = filters[keys[0]].value;
    console.log(typeof filters[keys[0]].value);
    if (keys.length > 0) {
        query = query + " WHERE " + "`"+mapFields(keys[0]) +"`"+ " "+getMatchMode(filters[keys[0]].matchMode)+" '" + getValue(filters[keys[0]].matchMode,cont) + "'"
        console.log(typeof cont);
        if (keys.length > 1) {
            for (var i = 1; i <= keys.length - 1; i++) {
                let cont2 = filters[keys[i]].value;
                query = query + " AND " + "`"+mapFields(keys[i]) +"`"+ " "+getMatchMode(filters[keys[i]].matchMode)+" '" + getValue(filters[keys[i]].matchMode,cont2) + "'";
            }
        }
    }
    if (sortField != 'undefined' && req.body.hasOwnProperty('sortField') && req.body.hasOwnProperty('sortOrder')) {
        if (sortOrder == 1) {
            query = query + " ORDER BY " +"`"+mapFields(sortField) +"`"+ " ASC ";
        }
        else {
            query = query + " ORDER BY " + "`"+mapFields(sortField)+"`"+ " DESC ";
        }

    }
    query = query + "limit ? OFFSET ?";
    //Mention table from where you want to fetch records example-users & send limit and start 
    var table = [table, rows, first];
    query = mysql.format(query, table);
    console.log(query);
    con.query(query, function (err, rest) {
        if (err) {
            res.json(err);
        }
        else {
            // Total Count varibale display total Count in Db and data display the records
            console.log(query);
            res.json({ "Total Count": totalCount, "data": rest });
        }
    });
    //res.send("yes");
});



function getMatchMode(matchMode)
{
if(matchMode=="contains")
return "LIKE"
else
return "="
}
function getValue(matchMode,value)
{
if(matchMode=="contains")
return  "%" + value + "%"
else
return value
}
app.listen(3000, function () {
    console.log("Started on PORT 3000");
})
function mapFields(field)
{
if(field=="TransactionWSStatus")
return "transaction_ws_status"
else if(field=="TransactionNumber")
return  "transaction_number"
else if (field=="TransactionPayStatus")
return "transaction_pay_status"
else
{return field}

}