var SqlString = require('sqlstring');
var mysql = require('mysql');
function myfunction(json, tablename) {

    var filters = json.filters;
    var first = json.first;
    var globalFilter = json.globalFilter;
    var rows = json.rows;
    var sortField = json.sortField;
    var sortOrder = json.sortOrder;
    var table = [tablename];
    // console.log(util.inspect(filters, false, null))
    // console.log(first + " " + globalFilter + " " + rows + " " + sortField + " " + sortOrder + " " + table);
    var query = "Select * from ??";
    var keys = [];
    for (var k in filters) keys.push(k);
    let cont = filters[keys[0]].value;
    if (keys.length > 0) {
        query = query + " WHERE " + "`" + mapFields(keys[0]) + "`" + " " + getMatchMode(filters[keys[0]].matchMode) + " '" + getValue(filters[keys[0]].matchMode, cont) + "'"
        if (keys.length > 1) {
            for (var i = 1; i <= keys.length - 1; i++) {
                let cont2 = filters[keys[i]].value;
                query = query + " AND " + "`" + mapFields(keys[i]) + "`" + " " + getMatchMode(filters[keys[i]].matchMode) + " '" + getValue(filters[keys[i]].matchMode, cont2) + "'";
            }
        }
    }
    if (sortField != 'undefined' && json.hasOwnProperty('sortField') && json.hasOwnProperty('sortOrder')) {
        if (sortOrder == 1) {
            query = query + " ORDER BY " + "`" + mapFields(sortField) + "`" + " ASC ";
        }
        else {
            query = query + " ORDER BY " + "`" + mapFields(sortField) + "`" + " DESC ";
        }

    }
    query = query + "limit ? OFFSET ?";
    //Mention table from where you want to fetch records example-users & send limit and start 
    var table = [table, rows, first];
    query = mysql.format(query, table);
    return query;

    //res.send("yes");
}
function getMatchMode(matchMode) {
    if (matchMode == "contains")
        return "LIKE"
    else
        return "="
}
function getValue(matchMode, value) {
    if (matchMode == "contains")
        return "%" + value + "%"
    else
        return value
}
function mapFields(field)
{
if(field=="TransactionWSStatus")
return "transaction_ws_status"
else if(field=="TransactionNumber")
return  "transaction_number"
else if (field=="TransactionPayStatus")
return "transaction_pay_status"
else
{return field}

}
myjson = {
    "filters": { //you can add multiple column for filtering
        "transaction_number": { //transaction_number is the column name
            "value": "56",
            "matchMode": "contains" //can be equal== '=' and contains== 'LIKE'
        },
        "supplier_id": {
            "value": 2,
            "matchMode": "equal" 
        },
        "supplier_name": {
            "value": "jack",
            "matchMode": "contains" 
        }
    },
    "first": 0,
    "rows": 10,
    "sortField": "total_amount",
    "sortOrder": 1
};
// mytable = "transactions";
// console.log(myfunction(myjson, mytable));
exports.json2sql=myfunction;